
// Line

class Line { 

  private ArrayList<PVector> lineCoord;
  public color strokeColor = color(255);
  public color fillColor = color(50);
  public float strokeWidth = 1.0f;

  // Constructor Function(s)
  Line () {  
    lineCoord = new ArrayList<PVector>();
  }  
  Line (float inStrokeWidth, color inStrokeColor) {
    lineCoord = new ArrayList<PVector>();
    strokeColor = inStrokeColor;
    strokeWidth = inStrokeWidth;
  }

  
  // Methods
  public void drawLine() {
   if (lineCoord.size() > 2) {
      fill(fillColor);
      stroke(strokeColor);
      strokeWeight(strokeWidth);
      noFill();
      beginShape();
      curveVertex(lineCoord.get(0).x, lineCoord.get(0).y);
      for (int i = 0; i < lineCoord.size(); i = i + 1) {
        curveVertex(lineCoord.get(i).x, lineCoord.get(i).y);
      }
      curveVertex(lineCoord.get(lineCoord.size()-1).x, lineCoord.get(lineCoord.size()-1).y);
      endShape(); 
    }
  }
  
  public void pushList (ArrayList<PVector> pushedList) {
    lineCoord.addAll(pushedList);
  }

  public void pushPoint (PVector pushedPoint) {
    if(lineCoord.size() == 0 || isInPointPerimiter(pushedPoint, lineCoord.get(lineCoord.size()-1), 8.0) == false) { 
      lineCoord.add(pushedPoint);
    }
  }
  
  public void pushPoint (PVector pushedPoint, int index) {
     if(lineCoord.size() == 0 || (isInPointPerimiter(pushedPoint, lineCoord.get(constrain(index-1, 0,lineCoord.size())), 8.0) == false && isInPointPerimiter(pushedPoint, lineCoord.get(constrain(index+1,0,lineCoord.size())), 8.0) == false)) { 
      lineCoord.add(index, pushedPoint);
    }
  }

  public ArrayList<PVector> getList () { 
    return lineCoord;
  }
  
  public PVector getPoint (int index) { 
    return lineCoord.get(index);
  }

} 

