/*
 Primitive Drawing Program
 David Simon  |  davidsimon.ch  | ZHdK IAD 2013
*/  
  // Main
  
  import controlP5.*;
  ControlP5 cp5;
  
  Slider sliderR;
  ColorPicker cp;
  Slider sliderStrokeWidth;
  
  ArrayList<Line> lines;
  boolean drawing, dirty = false;
  
  void setup () {
    
    // Settings
    size(600, 800);
    frameRate(60);
    lines = new ArrayList<Line>();
    
    cp5 = new ControlP5(this);
    initGUI();
                           
    // Setup
    background(255);
    fill(20);
    noStroke();
    rect(0,height-120,width,120);
  }
  
  // Variables used for draw()
  Line line;
  
  void draw () {
    
    if (drawing || dirty) {
      
      // Setup
      background(255);
    
      for (int i = 0; i < lines.size(); i = i + 1) {
        lines.get(i).drawLine();
      }
      
      // Draw GUI Segment
      fill(20);
      noStroke();
      rect(0,height-120,width,120);
      
      dirty = false; 
    }
  }
  
  void mouseDragged() {
     if (mouseY < height-90) {
      if (mouseButton == LEFT) {
          if (!drawing) {
            drawing = true;
            lines.add(new Line(sliderStrokeWidth.getValue(), cp.getColorValue()));
            lines.get(lines.size() - 1).pushPoint(new PVector(mouseX, mouseY));
          } else {
            lines.get(lines.size() - 1).pushPoint(new PVector(mouseX, mouseY));
          }
      } else if (mouseButton == RIGHT) {
        deleteFromPoint(new PVector(mouseX, mouseY));
      }
    }
  }
  void mouseReleased() {
    drawing = false;
  }
  
  void deleteFromPoint(PVector point) {
    Line line;
    PVector[] pvec;
    for (int i = lines.size() - 1; i >= 0; i = i - 1) {
      line = lines.get(i);
      for (int j = 0; j < line.getList().size(); j = j + 1) {
        if (isInPointPerimiter(line.getPoint(j), new PVector(mouseX, mouseY), 100.0) == true) {
          lines.remove(i);
          dirty = true;
          break;
        }
      }
    }
  }
  /* // Delte with Line-Circle Intersection
  void deleteFromPoint(PVector point) {
    Line line;
    PVector[] pvec;
    for (int i = lines.size() - 1; i >= 0; i = i - 1) {
      line = lines.get(i);
      pvec = new PVector[2];
      pvec[1] = line.getPoint(0);
      double min = width;
      for (int j = 0; j < line.getList().size()-1; j = j + 1) {
        pvec[0] = pvec[1]; 
        pvec[1] = line.getPoint(j+1);
        double d = pointToLineDistance(pvec[0], pvec[1], point);
        if (d < min) min = d;
        if (d < 10) {
          lines.remove(i);
          dirty = true;
          println(i+" / "+ j + " intersect" + d);
          break;
        }
      }
      println(min);
    }
  } */
